% This program illustrates Figure 2 in lecture note 
% "From the STFT to the Wigner Distributon", 
% by L. Stankovic, S. Stankovic, M.Dakovic
% in IEEE Signal Processing Magazine
clear all, close all

    x=signal_1; %Signal
    win=[0 sqrt(hanning(length(x)-1))']; Ew=sum(win.^2)/length(win);
    
    STFT=fftshift(fft(fftshift(x.*win))).'; %STFT
    STFT=STFT/sqrt(Ew)/length(win); %Normalization for the plot

%SM calculation with constant L
L=5; %Correction terms L: spectrogram L=0, WD L=length(x)/2-1, Suggested L=5
SM=SM_calc(STFT,L);

%Graphics
[N,K]=size(SM);
figure(1), stem(-N/2:N/2-1,SM), axis([-N/2 N/2-1 -.4 .9]), grid,
Meas=sum(sum(abs(SM).^0.5))/sum(sum(SM));
title(['L=',int2str(L),',   \mu[SM]=',num2str(Meas)]), 

%Time-frequency varying number of terms in SM
Q=1; %Correction level Q[%]: spectrogram Q=100, WD Q=0, Suggested Q=1
SM=SM_calc_TF(STFT,Q);

%Graphics
Meas=sum(sum(abs(SM).^0.5))/sum(sum(SM));
figure(2), stem(-N/2:N/2-1,SM), axis([-N/2 N/2-1 -.4 .9]), grid,
title(['Q=',num2str(Q),'[%],   \mu[SM]=',num2str(Meas)]),
