% This program illustrates Figure 2 in lecture note 
% "From the STFT to the Wigner Distributon", 
% by L. Stankovic, S. Stankovic, M.Dakovic
% in IEEE Signal Processing Magazine
clear all, close all

    x=signal_1; %Signal
    win=[0 sqrt(hanning(length(x)-1))']; Ew=sum(win.^2)/length(win);
    
    STFT=fftshift(fft(fftshift(x.*win))).'; %STFT
    STFT=STFT/sqrt(Ew)/length(win); %Normalization for the plot
IG=0;
%SM calculation with constant L
for L=[0 3 5 31]; %Correction terms L: spectrogram L=0, WD L=length(x)/2-1, Suggested L=5
SM=SM_calc(STFT,L);

IG=IG+1;
%Graphics
[N,K]=size(SM);
subplot(2,2,IG), stem(-N/2:N/2-1,SM), axis([-N/2 N/2-1 -.4 .9]), grid,
Meas=sum(sum(abs(SM).^0.5))/sum(sum(SM));
title(['L=',int2str(L),',   \mu[SM]=',num2str(Meas)]), 
end

