% This program illustrates Figure 2 in lecture note 
% "From the STFT to the Wigner Distributon", 
% by L. Stankovic, S. Stankovic, M.Dakovic
% in IEEE Signal Processing Magazine
clear all, close all

    x=signal_1; %Signal
    win=[0 sqrt(hanning(length(x)-1))']; Ew=sum(win.^2)/length(win);
    
    STFT=fftshift(fft(fftshift(x.*win))).'; %STFT
    STFT=STFT/sqrt(Ew)/length(win); %Normalization for the plot

IG=0;
%Time-frequency varying number of terms in SM
for Q=[100 10 0.5 0]; %Correction level Q[%]: spectrogram Q=100, WD Q=0, Suggested Q=1
SM=SM_calc_TF(STFT,Q);

IG=IG+1;
%Graphics
[N,K]=size(SM);
Meas=sum(sum(abs(SM).^0.5))/sum(sum(SM));
subplot(2,2,IG), stem(-N/2:N/2-1,SM), axis([-N/2 N/2-1 -.4 .9]), grid,
title(['Q=',num2str(Q),'[%],   \mu[SM]=',num2str(Meas)]),
end
