% This program illustrates Figure 3 in lecture note 
% "From the STFT to the Wigner Distributon", 
% by L. Stankovic, S. Stankovic, M.Dakovic
% in IEEE Signal Processing Magazine
clear all, close all

    N=128; % window width
    win=[0 (hanning(N-1))'];   Ew=sum(win.^2)/N;    
    STFT=[];
    for n=0:2:256
      x=signal_2(n,N);
      STFT=[STFT,fftshift(fft(fftshift([zeros(1,N/2), x.*win, zeros(1,N/2)]))).'];
    end
    STFT=STFT(N+1:2*N,:); %STFT positive frequencies
    STFT=STFT/sqrt(Ew)/N; %Normalization for the plot

%Constant L
L=10; %Correction terms: spectrogram L=0, WD L=length(x)/2-1, L=10 Suggested
SM=SM_calc(STFT,L);

%Graphics
[N,K]=size(SM);
figure(1), waterfall(SM'),  view([-5 55]), colormap([0 0 0]),
axis([0 N 0 K -0.5*4*(2*L-1).^2./(4*(2*L-1).^2+8) 4*(2*L-1).^2./(4*(2*L-1).^2+8)])
Meas=sum(sum(abs(SM).^0.5))/sum(sum(SM));
title(['L=',int2str(L),',   \mu[SM]=',num2str(Meas)]), 

%Time-frequency varying number of terms
Q=1; %Correction level [%]: spectrogram Q=100, WD Q=0, Q=1, Suggested
SM=SM_calc_TF(STFT,Q);

%Graphics
figure(2), waterfall(SM'),  view([-5 55]), colormap([0 0 0]),
axis([0 N 0 K -0.5*(15000-Q^2)/15000 1*(15000-Q^2)/15000])
Meas=sum(sum(abs(SM).^0.5))/sum(sum(SM));
title(['Q=',num2str(Q),'[%],   \mu[SM]=',num2str(Meas)]),
