% This program illustrates Figure 3 in lecture note 
% "From the STFT to the Wigner Distributon", 
% by L. Stankovic, S. Stankovic, M.Dakovic
% in IEEE Signal Processing Magazine
clear all, close all

    N=128; % window width
    win=[0 (hanning(N-1))'];   Ew=sum(win.^2)/N;    
    STFT=[];
    for n=0:4:256
      x=signal_2(n,N);
      STFT=[STFT,fftshift(fft(fftshift([zeros(1,N/2), x.*win, zeros(1,N/2)]))).'];
    end
    STFT=STFT(N+1:2*N,:); %STFT positive frequencies
    STFT=STFT/sqrt(Ew)/N; %Normalization for the plot

IG=0;
%Time-frequency varying number of terms
for Q=[100 10 1 0]; %Correction level [%]: spectrogram Q=100, WD Q=0, Q=1, Suggested
SM=SM_calc_TF(STFT,Q);
IG=IG+1;

%Graphics
[N,K]=size(STFT);
subplot(2,2,IG),, waterfall(SM'),  view([-5 55]), colormap([0 0 0]),
axis([0 N 0 K -0.5*(15000-Q^2)/15000 1*(15000-Q^2)/15000])
Meas=sum(sum(abs(SM).^0.5))/sum(sum(SM));
title(['Q=',num2str(Q),'[%],   \mu[SM]=',num2str(Meas)]),
end
