function SM=SM_calc_TF(S,Q)
%The S-method calculation with Q as reference level 
% Included are correction terms that are greater than Q[%] 
% of the maximal STFT value (Q=100 no correction, Q=0 is the WD all correction)
%Input S is the STFT matrix (frequency index is row index in matrix)
[N,K]=size(S);
    SM=abs(S).^2;
    Ref=max(max(abs(S)))*Q/100;
    for n=1:K
        for k=1:N
            for i=1:N/2-1
                if (k-i>0)&(k+i<=N)&(abs(S(k+i,n))>Ref)&(abs(S(k-i,n))>Ref)
                    SM(k,n)=SM(k,n)+2*real(S(k+i,n).*conj(S(k-i,n)));
                else break
                end
            end
        end
    end
end
